/*--------------------------------------------------------*/
/* form.c                                08-aug-1997/bets */
/* based on code from pablo                               */
/*--------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "page.h"
#include "cgi.h"
#include "form.h"

int form_varcount = 0;
entry form_varentries[MAX_ENTRIES];


/*--------------------------------------------------------*/
/* form_getvar                                            */
/* this routine returns the value of the variable named   */
/* thename from the internal array of variable name/value */
/* pairs                                                  */
/*--------------------------------------------------------*/
char *form_getvar( char *thename ) {
  int i;
  for ( i=0; i<form_varcount; i++ ) 
    if ( ! strcmp( form_varentries[i].name,thename ))
      return form_varentries[i].value;
  return NULL;
} /* end of form_getvar() */
 

/*--------------------------------------------------------*/
/* form_getenv                                            */
/* this routine returns the value of the environment      */
/* variable named thename                                 */
/*--------------------------------------------------------*/
char *form_getenv( char *thename ) {
  char *value;
  value = getenv( thename );
  if ( value == NULL ) {
      page_error( "%s%s",
		  "CgiException: Cannot read environment variable ",
		  thename );
      exit( 1 );
    }
  return value;
} /* end of form_getenv() */
    

/*--------------------------------------------------------*/
/* form_process                                           */
/* this routine processes GET and POST forms.             */
/* a GET form is processed by reading the QUERY_STRING    */
/* environment variable, parsing its contents and loading */
/* them into the internal array of variable name/values   */
/* pairs.                                                 */
/* a POST form is processed by reading from stdin, parsing*/
/* the input and loading it into the internal variable    */
/* array, as above.                                       */
/* this routine returns 0 if there are no variables to    */
/* process, else 1.                                       */
/*--------------------------------------------------------*/
int form_process() {
  entry *entries = form_varentries;
  int x, m = 0, cl;
  char *pcl, vname[1000], vvalue[1000];
  char *method = form_getenv( "REQUEST_METHOD" );
  for ( x=0; method[x]; x++ )
    method[x] = toupper( method[x] );
  if ( ! strcmp( method,"GET" )) {
      /* GET form */
    pcl = form_getenv( "QUERY_STRING" );
    if (( pcl == NULL ) ||
	( strlen( pcl ) == 0 )) {
      return( 0 );
    }
    m = 0;
    form_varcount = 0;
    for( x=0; pcl[0] != '\0'; x++ ) {
      m = x;
      cgi_getword( vvalue,pcl,'&' );
      cgi_plus2space( vvalue );
      cgi_unescape_url( vvalue );
      cgi_getword( vname,vvalue,'=' );
      if (( entries[x].name = 
	    (char *)malloc( strlen( vname ) + 2 )) == 
	  NULL ) {
	page_error( "CgiExeption: out of memory" );
	exit( 1 );
      }
      entries[x].value = 
	(char *)malloc( strlen( vvalue ) + 2 );
      if (( entries[x].name = 
	    (char *)malloc( strlen( vname ) + 2 )) == 
	  NULL ) {
	page_error( "CgiExeption: out of memory" );
	exit( 1 );
      }
      strcpy( entries[x].name,vname );
      strcpy( entries[x].value,vvalue );
      form_varcount++;
    }
  }
  else if ( ! strcmp( method,"POST" )) {
    /* POST form */
    cl = atoi( form_getenv( "CONTENT_LENGTH" ));
    if ( cl == 0 ) {
      return( 0 );
    }
    for ( x=0; cl && ( !feof( stdin )); x++ ) {
      m = x;
      entries[x].value = cgi_fmakeword( stdin,'&',&cl );
      cgi_plus2space( entries[x].value );
      cgi_unescape_url( entries[x].value );
      entries[x].name = cgi_makeword( entries[x].value,'=');
      form_varcount++;
    }
  }
  else {
    page_error( "CgiException: invalid method" );
    exit( 1 );
  }
  
  return( 1 );
} /* end of form_process() */



/*--------------------------------------------------------*/
/* form_begin                                             */
/* this routine outputs to stdout the html commands       */
/* necessary at the start of a form                       */
/*--------------------------------------------------------*/
void form_begin( char *action ) {
  fprintf( stdout,"<form method=\"POST\" action=\"%s\">\n",action );
} /* end of form_begin() */


/*--------------------------------------------------------*/
/* form_end                                               */
/* this routine outputs to stdout the html commands       */
/* necessary at the end of a form                         */
/*--------------------------------------------------------*/
void form_end() {
  fprintf( stdout,"</form>\n" );
} /* end of form_end() */

